/* initialize our protobuf schema,
   and cache it in memory. */
var ProtoBuf;
if (!ProtoBuf) {
    ProtoBuf    = require('protobufjs');
    var builder = ProtoBuf.loadProtoFile(__dirname + "/proto/proto.proto");
    var root = builder.build();
    var Event = root.Event;
    var State = root.State;
    var Query = root.Query;
    var Msg = root.Msg;
    var Attribute = root.Attribute;
}

/* serialization support for all
   known Riemann protobuf types. */

exports.serializeEvent = function(event) {
    return event.encode();
};

exports.deserializeEvent = function(event) {
    return new Event(event);
};

exports.serializeMessage = function(message) {
    return message.encode();
};

exports.deserializeMessage = function(message) {
    return new Msg(message);
};

exports.serializeQuery = function(query) {
    return query.encode();
};

exports.deserializeQuery = function(query) {
    return new Query(query);
};

exports.serializeState = function(state) {
    return state.encode();
};

exports.deserializeState = function(state) {
    return State(state);
};
